'CC.inc

Declare Function CoRegisterClassObjectPtr Lib "OLE32.DLL" Alias "CoRegisterClassObject" _
( _
  Byref rclsid            As Guid, _   'This is an alternate form of CoRegisterClassObject()
  Byval pUnknown          As Dword, _  'as the one in Jose's includes doesn't seem to work
  Byval dwClsContext      As Dword, _  'with low level do it yourself COM code such as this 
  Byval flags             As Dword, _  '(at least not with mine!).
  ByRef lpdwRegister      As Dword _
) As Long                
 
                          'IClassFactory1 Interface Function Pointers
Declare Function          ptrCreateInstance (Byval this As Dword, Byval pUnk As Dword, Byref iid As Guid, Byref ppv As Dword) As Long
Declare Function          ptrLockServer     (Byval this As Dword, Byval blnLock As Long                                     ) As Long

                          'IX, IY Interface Function Pointer Prototypes
Declare Function          ptrQueryInterface (Byval this As Dword, Byref iid As Guid, Byref pUnknown As Dword                ) As Long
Declare Function          ptrAddRef         (Byval this As Dword                                                            ) As Dword
Declare Function          ptrRelease        (Byval this As Dword                                                            ) As Dword
Declare Function          ptrSetInt         (Byval this As Dword, Byval iVal As Long                                        ) As Long
Declare Function          ptrGetInt         (Byval this As Dword, Byref pVal As Long                                        ) As Long
Declare Function          ptrSetText        (Byval this As Dword, Byval strText As String                                   ) As Long
Declare Function          ptrGetText        (Byval this As Dword, Byref ptrText As String                                   ) As Long

$IID_IClassFactory        =  Guid$("{00000001-0000-0000-C000-000000000046}")
$IID_IUnknown             =  Guid$("{00000000-0000-0000-C000-000000000046}")
$CLSID_CC                 =  Guid$("{20000000-0000-0000-0000-000000000020}")
$IID_IX                   =  Guid$("{20000000-0000-0000-0000-000000000021}")
$IID_IY                   =  Guid$("{20000000-0000-0000-0000-000000000022}")
$LIBID_CCLibrary          =  Guid$("{20000000-0000-0000-0000-000000000023}")

Type IXVtbl                             'I've covered the creation of COM objects in my first two tutorials in some detail, so I'll
  QueryInterface          As Dword Ptr  'just give a quick review here.  A COM class contains state data, i.e., instance variables,    
  AddRef                  As Dword Ptr  'and VTable pointers, i.e., pointers to interfaces.  If you look at Type CC below, that is 
  Release                 As Dword Ptr  'a COM class, and it contains two VTable (interface) pointers, and five member variables.  Its
  SetXInt                 As Dword Ptr  'size is therefore 28 bytes.  The 1st two members are, respectively, pointers to the IX and 
  GetXInt                 As Dword Ptr  'IY interfaces, which are contiguous blocks of memory containing pointers to the interface
  SetXText                As Dword Ptr  'functions.  Bytes 8 through 24 in Type CC are the four instance variables on which the IX
  GetXText                As Dword Ptr  'and IY interface functions work.  They simply Get/Set these variables.  The last four bytes
End Type                                'of CC are a reference counting variable that keeps track of how many outstanding references

Type I_X                                'there are on Class CC and its interfaces.  Type IXVtbl and Type IYVtbl are UDTs which upon
  lpIX                    As IXVtbl Ptr 'creation provide memory space where pointers to the interface functions will be stored.  For
End Type                                'example, if you look down in this code file around line 180 you'll see the function SetXInt().

Type IYVtbl                             'The address of this function retrieved at runtime by the PowerBASIC CodePtr() function will  
  QueryInterface          As Dword Ptr  'be stored in the SetXInt member of IXVtbl.  Likewise for the other IXVtbl functions.  Note
  AddRef                  As Dword Ptr  'that every interface has QueryInterface, AddRef, and Release pointers stored as the 1st three
  Release                 As Dword Ptr  'function pointers of the interface.  This adds reference counting and interface navigation
  SetYInt                 As Dword Ptr  'functionality to the interfaces.  These three members are a part of something termed
  GetYInt                 As Dword Ptr  'IUnknown, and if we were using C++ terminology one would say all COM interfaces inherit from
  SetYText                As Dword Ptr  'IUnknown, which is just another way of aying that every interface has QueryInterface, AddRef,
  GetYText                As Dword Ptr  'and Release as its 1st three members.
End Type

Type I_Y
  lpIY                    As IYVtbl Ptr 'For this program to be started by COM it has to be registered 1st.  You don't use RegSvr32
End Type                                'for that.  You must open a command prompt window to whatever directory CC.exe is in.  Then

Type CC                                 'you must execute the program with a /r command line parameter...
  lpIX                    As IXVtbl Ptr
  lpIY                    As IYVtbl Ptr '                        C:\Code\PwrBasic\PBWin90\CC>CC.exe /r
  m_iXInt                 As Long       '
  m_iYInt                 As Long       'Having done that if the registration was successful you should be able to use the program
  m_XText                 As Dword Ptr  'like any other local exe server from C/C++, vb.net, PowerBASIC, etc.
  m_YText                 As Dword Ptr
  m_cRef                  As Long
End Type

Type IClassFactoryVtbl                  'When this program starts up in WinMain(), irregardless of whether it was started with
  QueryInterface          As Dword Ptr  'a command line argument by COM, a Class Factory will be created in Initialize().  If
  AddRef                  As Dword Ptr  '/r or /u was passed in for registration/unregistration, the program will simply perform
  Release                 As Dword Ptr  'an early exit from WinMain() and terminate.  If however, a /Embedding or -Embedding
  CreateInstance          As Dword Ptr  'String was passed in to WinMain(), then the program was started by COM's Service Control
  LockServer              As Dword Ptr  'Manager, and CoRegisterClassObject() needs to be called to register the Class Factory with
End Type                                'COM so that it can create an instance of CC for a client.  The critical variable passed...
          
Type IClassFactory1                     
  lpVtbl                  As IClassFactoryVtbl Ptr
End Type

Global g_szFriendlyName   As Asciiz*64  '...into CoRegisterClassObject() is the address of the CCClassFactory variable of type
Global g_szVerIndProgID   As Asciiz*64  'IClassFactory1 just defined above.  Note in this app CCClassFactory is just a global
Global g_szProgID         As Asciiz*64  'variable.  
Global CCClassFactory     As IClassFactory1     'sizeof() =  4
Global IClassFactory_Vtbl As IClassFactoryVtbl  'sizeof() = 20
Global IX_Vtbl            As IXVtbl             'sizeof() = 28
Global IY_Vtbl            As IYVtbl             'sizeof() = 28
Global g_hModule          As Dword
Global g_lLocks           As Long
Global pIX                As Dword Ptr  'When COM gets the address of the class factory object, it can then call the all important
Global pIY                As Dword Ptr  'CCClassFactory_CreateInstance() function which will create a CC object, that is, a COM object
Global hMainWnd           As Dword      'of class ComObject.CC.  Note that the above function allocates memory for a CC object with...


Sub CCLock()                                              '...CoTaskMemAlloc(), attaches the VTbl pointers to the object, and                                  
  Prnt "  Entering CCLock()", 1                           'initializes the state (instance) variables of the object to default values.
  Prnt "    g_lLocks = " & Str$(g_lLocks), 1
  Call InterlockedIncrement(g_lLocks)
  Prnt "    g_lLocks = " & Str$(g_lLocks), 1
  Prnt "  Leaving CCLock()", 1
End Sub


Sub CCUnLock()                                            'Its important to realize what keeps this program running if an early exit            
  If g_lLocks > 0 Then                                    'doesn't occur due to the registration/unregistration scenerio.  If execution
     Prnt "Entering CCUnLock()", 1                        'reaches the CreateWindow() call in WinMain(), a main program window will be
     Prnt "  g_lLocks = " & Str$(g_lLocks), 1             'created and the program will enter a message retrieval loop.  If the main
     Call InterlockedDecrement(g_lLocks)                  'program window receives a click on the [x] to terminate it, Release() calls 
     Prnt "  g_lLocks = " & Str$(g_lLocks), 1             'will be made on the globally allocated IX and IY interface variables, and
     If g_lLocks=0 Then                                   'a DestroyWindow() call and PostQuitMessage() call made on the main window
        If hMainWnd Then                                  'and WinMain()'s message pump.  If the program was started by COM and the
           Call PostQuitMessage(0)                        'main window is invisible, a WM_CLOSE message and PostQuitMessage() will be 
           Call SendMessage(hMainWnd, %WM_CLOSE, 0, 0)    'SendMessag()'ed from CCUnlock() when g_lLocks reaches 0.
        End If   
     End If   
     Prnt "Leaving CCUnLock()", 1
  End If   
End Sub


Function IX_QueryInterface(ByVal this As I_X Ptr, ByRef iid As Guid, ByVal ppv As Dword Ptr) As Long
  @ppv=%NULL
  Select Case iid
    Case $IID_IUnknown
      Prnt "  Called IX_QueryInterface() For IID_IUnknown And this=" & Str$(this), 1
      @ppv=this
      Call IX_AddRef(this)
      Function=%S_OK
      Exit Function
    Case $IID_IX
      Prnt "  Called IX_QueryInterface() For IID_IX And this=" & Str$(this), 1
      @ppv=this
      Call IX_AddRef(this)
      Function=%S_OK
      Exit Function
    Case $IID_IY
      Prnt "  Called IX_QueryInterface() For IID_IY And this=" & Str$(this), 1
      Incr this
      @ppv=this
      Call IY_AddRef(this)
      Function=%S_OK
      Exit Function
    Case Else
      Prnt "Called IX_QueryInterface()", 1
  End Select

  Function=%E_NoInterface
End Function


Function IX_AddRef(ByVal this As I_X Ptr) As Long
  Local pCC As CC Ptr
  
  Prnt "Called IX_AddRef()", 1
  pCC=this
  Incr @pCC.m_cRef

  IX_AddRef=@pCC.m_cRef
End Function


Function IX_Release(ByVal this As I_X Ptr) As Long
  Local pCC As CC Ptr
  
  pCC=this
  Decr @pCC.m_cRef
  If @pCC.m_cRef=0 Then
     Call CoTaskMemFree(this)
     Prnt "Called IX_Release() And CC Was Deleted!", 1
     Call CCUnLock()
  Else
     Prnt "Called IX_Release()", 1
  End If

  Function=@pCC.m_cRef
End Function


Function SetXInt(ByVal this As I_X Ptr, Byval iXVal As Long) As Long
  Local pCC As CC Ptr
  
  Prnt "Called SetXInt(" & Trim$(Str$(iXVal)) & ")", 1
  pCC=this
  @pCC.m_iXInt=iXVal

  Function=%S_OK
End Function


Function GetXInt(ByVal this As I_X Ptr, Byref pXVal As Long) As Long
  Local pCC As CC Ptr
  
  pCC=this
  pXVal=@pCC.m_iXInt
  Prnt "Called GetXInt(" & Trim$(Str$(pXVal)) & ")", 1

  Function=%S_OK
End Function


Function SetXText(ByVal this As I_X Ptr, Byval strXText As String) As Long
  Local pCC As CC Ptr
  
  Prnt "Setting IXText To " & strXText, 1
  pCC=this
  If SysReAllocString(@pCC.m_XText, Byval Strptr(strXText)) Then
     Function=%S_OK
  Else
     Function=%S_FALSE
  End If
End Function


Function GetXText(ByVal this As I_X Ptr, Byref strXText As String) As Long
  Local pCC As CC Ptr
  
  pCC=this
  If SysReAllocString(strXText, Byval @pCC.m_XText) Then
     Function=%S_OK
  Else
     Function=%S_FALSE
  End If
  Prnt "IX Text: " & strXText, 1
End Function


Function IY_QueryInterface(ByVal this As I_Y Ptr, ByRef iid As Guid, ByVal ppv As Dword Ptr) As Long
  @ppv=%NULL
  Select Case iid
    Case $IID_IUnknown
      Prnt "Called IY_QueryInterface() For IID_IUnknown", 1
      Decr this
      @ppv=this
      Call IX_AddRef(this)
      Function=%S_OK
      Exit Function
    Case $IID_IX
      Prnt "Called IY_QueryInterface() For IID_IX", 1
      Decr this
      @ppv=this
      Call IX_AddRef(this)
      Function=%S_OK
      Exit Function
    Case $IID_IY
      Prnt "Called IY_QueryInterface() For IID_IY", 1
      @ppv=this
      Call IY_AddRef(this)
      Function=%S_OK
      Exit Function
    Case Else
      Prnt "Called IY_QueryInterface()", 1
  End Select

  Function=%E_NoInterface
End Function


Function IY_AddRef(ByVal this As I_Y Ptr) As Long
  Local pCC As CC Ptr
  
  Prnt "Called IY_AddRef() - this = " & Str$(this), 1
  Decr this
  pCC=this
  Incr @pCC.m_cRef

  IY_AddRef=@pCC.m_cRef
End Function


Function IY_Release(ByVal this As I_Y Ptr) As Long
  Local pCC As CC Ptr
  
  Decr this
  pCC=this
  Decr @pCC.m_cRef
  If @pCC.m_cRef=0 Then
     Call CoTaskMemFree(this)
     Prnt "Called IY_Release() And CC Was Deleted!", 1
     Call CCUnLock()
  Else
     Prnt "Called IY_Release()", 1
  End If

  Function=@pCC.m_cRef
End Function


Function SetYInt(ByVal this As I_Y Ptr, Byval iYVal As Long) As Long
  Local pCC As CC Ptr
  
  Prnt "Called SetYInt(" & Trim$(Str$(iYVal)) & ")", 1
  Decr this
  pCC=this
  @pCC.m_iYInt=iYVal

  Function=%S_OK
End Function


Function GetYInt(ByVal this As I_Y Ptr, Byref pYVal As Long) As Long
  Local pCC As CC Ptr
  
  Decr this
  pCC=this
  pYVal=@pCC.m_iYInt
  Prnt "Called GetXInt(" & Trim$(Str$(pYVal)) & ")", 1

  Function=%S_OK
End Function


Function SetYText(ByVal this As I_Y Ptr, Byval strYText As String) Export As Long
  Local pCC As CC Ptr
  
  Prnt "Setting IYText To " & strYText, 1
  Decr this
  pCC=this
  If SysReAllocString(@pCC.m_YText, Byval Strptr(strYText)) Then
     Function=%S_OK
  Else
     Function=%S_FALSE
  End If
End Function


Function GetYText(ByVal this As I_Y Ptr, Byref strYText As String) Export As Long
  Local pCC As CC Ptr
  
  Decr this
  pCC=this
  If SysReAllocString(strYText, Byval @pCC.m_YText) Then
     Function=%S_OK
  Else
     Function=%S_FALSE
  End If
  Prnt "IY Text: " & strYText, 1
End Function


Function CCClassFactory_QueryInterface(ByVal this As IClassFactory1 Ptr, ByRef RefIID As Guid, ByVal pCF As Dword Ptr) As Long
  Prnt "Called CCClassFactory_QueryInterface()", 1
  If RefIID=$IID_IUnknown Or RefIID=$IID_IClassFactory Then
     Call CCClassFactory_AddRef(this)
     @pCF=this
     Prnt "  Leaving CCClassFactory_QueryInterface()", 1
     Function=%NOERROR
     Exit Function
  End If

  Function=%E_NoInterface
End Function


Function CCClassFactory_AddRef(ByVal this As IClassFactory1 Ptr) As Long
  Prnt "Called CCClassFactory_AddRef()!", 1
  'Print "    Leaving CCClassFactory_AddRef()!"
  CCClassFactory_AddRef=10
End Function


Function CCClassFactory_Release(ByVal this As IClassFactory1 Ptr) As Long
  Prnt "Called CCClassFactory_Release()!", 1
  'Print "    this=" this
  'Print "  Leaving CCClassFactory_Release()!"
  CCClassFactory_Release=20
End Function


Function CCClassFactory_CreateInstance(ByVal this As IClassFactory1 Ptr, ByVal pUnknown As Dword, ByRef RefIID As Guid, ByVal ppv As Dword Ptr) As Long
  Local strIXStr, strIYStr As String
  Local pIX As I_X Ptr
  Local pCC As CC Ptr
  Local hr  As Long
  
  Prnt "Called CCClassFactory_CreateInstance()", 1
  @ppv=%NULL
  If pUnknown Then
     hr=%CLASS_E_NOAGGREGATION
     Exit Function
  Else
     If RefIID=$IID_IUnknown Or RefIID=$IID_IX Or RefIID=$IID_IY Then
        pCC=CoTaskMemAlloc(SizeOf(CC))
        If pCC Then
           Prnt "  pCC      =" & Str$(pCC), 1
           @pCC.lpIX=VarPtr(IX_Vtbl)               
           @pCC.lpIY=VarPtr(IY_Vtbl)
           Prnt "  @pCC.lpIX=" & Str$(@pCC.lpIX), 1          
           Prnt "  @pCC.lpIY=" & Str$(@pCC.lpIY), 1 
           Prnt "", 1 
           Prnt " " & Str$(Varptr(@pCC.lpIX)) & "    ", 0 : Prnt Str$(@pCC.lpIX), 1  
           Prnt " " & Str$(Varptr(@pCC.lpIY)) & "    ", 0 : Prnt Str$(@pCC.lpIY), 1  
           Prnt "",1 
           strIXStr="Default IX Interface String"  
           strIYStr="Default IY Interface String"
           strIXStr=UCode$(strIXStr)               
           strIYStr=UCode$(strIYStr)
           @pCC.m_XText=SysAllocStringLen(Byval Strptr(strIXStr),Len(strIXStr)+1)
           @pCC.m_YText=SysAllocStringLen(Byval Strptr(strIYStr),Len(strIYStr)+1)
           @pCC.m_iXInt=0     :   @pCC.m_iYInt=0   :    @pCC.m_cRef=0
           pIX=pCC
           hr= IX_QueryInterface(pIX,RefIID,ppv)
           Prnt "  pCC  = " & Str$(pCC), 1
           Prnt "  pIX  = " & Str$(pIX), 1
           Prnt "  @ppv = " & Str$(@ppv), 1
           If SUCCEEDED(hr) Then
              Call CCClassFactory_AddRef(this)
              Call CCLock()
           Else
              Call CoTaskMemFree(pCC)
              CCClassFactory_CreateInstance=%E_FAIL
              Prnt "", 1 : Prnt "CreateInstance Failed!", 1
              Exit Function
           End If
        Else
           hr=%E_OutOfMemory
           Exit Function
        End If
     Else   
        hr=%E_FAIL
        Exit Function
     End If
  End If   
  Prnt "Leaving CBClassFactory_CreateInstance()", 1

  CCClassFactory_CreateInstance=%S_Ok
End Function


Function CCClassFactory_LockServer(ByVal this As IClassFactory1 Ptr, Byval flock As Long) As Long
  Prnt "Called CCClassFactory_LockServer()", 1
  If flock Then
     Call CCLock()
  Else
     Call CCUnLock()
  End If

  CCClassFactory_LockServer=%NOERROR
End Function


Function ExeRegisterServer(hInstance As Long) As Long
  Local strAsciPath,strWideCharPath As String
  Local hr,iBytesReturned As Long
  Local szPath As Asciiz*256
  Local pTypeLib As ITypeLib
  Local strPath As String
  
  Prnt "  Entering ExeRegisterServer()", 1
  If GetModuleFileName(hInstance, szPath, 256) Then
     strPath=szPath
     Prnt "    szPath         = " & strPath, 1
     strAsciPath=szPath
     strWideCharPath=UCode$(strAsciPath & $Nul)
     hr=LoadTypeLibEx(Strptr(strWideCharPath), %REGKIND_REGISTER, pTypeLib)
     If SUCCEEDED(hr) Then
        Prnt "    LoadTypeLib() Succeeded!", 1
        Set pTypeLib = Nothing
        hr=RegisterServer(szPath, $CLSID_CC, $LIBID_CCLibrary, g_szFriendlyName, g_szVerIndProgID, g_szProgID)
     Else
        Local dwFlags As Dword
        Local szError As Asciiz*256
        Local strError As String
        Prnt "    LoadTypeLib() Failed!", 1
        iBytesReturned= _
        FormatMessage _
        ( _
          dwFlags, _
          Byval 0, _
          hr, _
          MAKELANGID(%LANG_NEUTRAL, %SUBLANG_DEFAULT), _
          Byval Varptr(szError), _
          256, _
          Byval %NULL _
        )
        If iBytesReturned=0 Then
           iBytesReturned=MsgBox("...And That Is To Use PBTyp.exe To Embed The Type Library In The Exe!", %MB_ICONWARNING, "I Know What You Forgot...")
        End If 
        strError=szError
        Prnt "    iBytesReturned = " & Str$(iBytesReturned), 1
        Prnt "szBuffer           = " & strError, 1
     End If
  End If
  Prnt "  Leaving ExeRegisterServer()", 1
  
  Function=hr
End Function


Function ExeUnRegisterServer(hInstance As Long) As Long
  Local hr As Long
  
  Prnt "  Entering ExeUnregisterServer()", 1
  hr=UnRegisterTypeLib($LIBID_CCLibrary, 1, 0, %LANG_NEUTRAL, %SYS_WIN32)
  If SUCCEEDED(hr) Then
     Prnt "    UnRegisterTypeLib() Succeeded!", 1
     hr=UnregisterServer($CLSID_CC, g_szVerIndProgID, g_szProgID)
  Else
     Prnt "    UnRegisterTypeLib() Failed!", 1   
  End If 
  Prnt "  Leaving ExeUnregisterServer()", 1
  
  Function=hr
End Function


Function CmdLineProcessing _
( _
  Byval hInstance As Long, _
  Byval lpCmdLine As Asciiz Ptr, _
  Byref regID As Dword, _
  Byref blnFailure As Long _
) As Long
  Local hr As Long

  Prnt "Entering blnCmdLineProcessing()", 1
  If InStr(@lpCmdLine,"/r") Then
     Prnt "  Calling ExeRegisterServer()", 1
     hr=ExeRegisterServer(hInstance)
     If SUCCEEDED(hr) Then
        Prnt "  ExeRegisterServer() Apparently Succeeded!", 1
     Else
        Prnt "  ExeRegisterServer() Apparently Failed!", 1   
     End If   
     Prnt "Leaving blnCmdLineProcessing()", 1
     Prnt "", 1
     Function=%TRUE
     Exit Function
  End If
  If InStr(@lpCmdLine,"/u") Then
     Prnt "  Calling ExeUnregisterServer()", 1
     hr=ExeUnregisterServer(hInstance)
     If SUCCEEDED(hr) Then
        Prnt "  ExeUnregisterServer Apparently Succeeded!", 1
     Else
        Prnt "  ExeUnregisterServer Apparently Failed!", 1
     End If    
     Prnt "Leaving blnCmdLineProcessing()", 1
     Prnt "", 1
     Function=%TRUE
     Exit Function
  End If
  If InStr(@lpCmdLine,"/Embedding") Or InStr(@lpCmdLine,"-Embedding") Then
     Prnt "  Was Loaded By COM!", 1
     hr=CoRegisterClassObjectPtr($CLSID_CC, Varptr(CCClassFactory), %CLSCTX_LOCAL_SERVER, %REGCLS_MULTIPLEUSE, regID)
     If SUCCEEDED(hr) Then
        Prnt "  CoRegisterClassObject() Succeeded!", 1
     Else
        Prnt "CoRegisterClassObject() Failed!", 1
        blnFailure=%TRUE
        Local dwFlags As Dword
        Local szError As Asciiz*256
        Local strError As String
        dwFlags=%FORMAT_MESSAGE_FROM_SYSTEM
        FormatMessage(dwFlags, Byval 0, hr, MAKELANGID(%LANG_NEUTRAL, %SUBLANG_DEFAULT), Byval Varptr(szError), 256, Byval %NULL)
        strError=szError
        Prnt "strBuffer = " & strError, 1
    End If
  End If  
  Prnt "Leaving blnCmdLineProcessing()", 1
  Prnt "", 1

  Function=%FALSE
End Function


Function Initialize() As Long
  Local pClsFac As Dword Ptr
  Local hr As Long

  Prnt "Entering Initialize()", 1 
  g_szFriendlyName                           = "Com Object CC"
  g_szProgID                                 = "ComObject.CC.1"
  g_szVerIndProgID                           = "ComObject.CC"
  IClassFactory_Vtbl.QueryInterface          = CodePtr(CCClassFactory_QueryInterface)
  IClassFactory_Vtbl.AddRef                  = CodePtr(CCClassFactory_AddRef)
  IClassFactory_Vtbl.Release                 = CodePtr(CCClassFactory_Release)
  IClassFactory_Vtbl.CreateInstance          = CodePtr(CCClassFactory_CreateInstance)
  IClassFactory_Vtbl.LockServer              = CodePtr(CCClassFactory_LockServer)
  CCClassFactory.lpVtbl                      = VarPtr(IClassFactory_Vtbl)
  Prnt "  IClassFactory_Vtbl.QueryInterface = " & Str$(IClassFactory_Vtbl.QueryInterface), 1
  Prnt "  IClassFactory_Vtbl.AddRef         = " & Str$(IClassFactory_Vtbl.AddRef), 1
  Prnt "  IClassFactory_Vtbl.Release        = " & Str$(IClassFactory_Vtbl.Release), 1
  Prnt "  IClassFactory_Vtbl.CreateInstance = " & Str$(IClassFactory_Vtbl.CreateInstance), 1
  Prnt "  IClassFactory_Vtbl.LockServer     = " & Str$(IClassFactory_Vtbl.LockServer), 1
  Prnt "", 1
  Prnt "  Varptr(CCClassFactory)            = " & Str$(Varptr(CCClassFactory)), 1
  Prnt "  Varptr(CCClassFactory.lpVtbl)     = " & Str$(Varptr(CCClassFactory.lpVtbl)), 1
  Prnt "  Varptr(IClassFactory_Vtbl)        = " & Str$(Varptr(IClassFactory_Vtbl)), 1
  Prnt "  CCClassFactory.lpVtbl             = " & Str$(CCClassFactory.lpVtbl), 1  
  IX_Vtbl.QueryInterface                     = CodePtr(IX_QueryInterface)
  IX_Vtbl.AddRef                             = CodePtr(IX_AddRef)
  IX_Vtbl.Release                            = CodePtr(IX_Release)
  IX_Vtbl.SetXInt                            = CodePtr(SetXInt)
  IX_Vtbl.GetXInt                            = CodePtr(GetXInt)
  IX_Vtbl.SetXText                           = CodePtr(SetXText)
  IX_Vtbl.GetXText                           = CodePtr(GetXText)
  IY_Vtbl.QueryInterface                     = CodePtr(IY_QueryInterface)
  IY_Vtbl.AddRef                             = CodePtr(IY_AddRef)
  IY_Vtbl.Release                            = CodePtr(IY_Release)
  IY_Vtbl.SetYInt                            = CodePtr(SetYInt)
  IY_Vtbl.GetYInt                            = CodePtr(GetYInt)
  IY_Vtbl.SetYText                           = CodePtr(SetYText)
  IY_Vtbl.GetYText                           = CodePtr(GetYText)
  hr=CCClassFactory_QueryInterface(VarPtr(CCClassFactory), $IID_IClassFactory, Varptr(pClsFac))
  If FAILED(hr) Then
     CCClassFactory.lpVTbl=0
     hr=%CLASS_E_CLASSNOTAVAILABLE
     Exit Function
  Else
     Prnt "  pClsFac = " & Str$(pClsFac), 1
  End If
  Prnt "Leaving Initialize()", 1 : Prnt "", 1

  Function=hr
End Function
